- name: Copy K3s service file
  register: k3s_service
  template:
    src: "k3s.service.manager.j2"
    dest: "{{ systemd_dir }}/k3s.service"
    owner: root
    group: root
    mode: 0755

- name: Enable and check K3s service
  systemd:
    name: k3s
    daemon_reload: yes
    state: restarted
    enabled: yes

- name: Wait for node-token
  wait_for:
    path: /var/lib/rancher/k3s/server/node-token

- name: Register node-token file access mode
  stat:
    path: /var/lib/rancher/k3s/server
  register: p

- name: Change file access node-token
  file:
    path: /var/lib/rancher/k3s/server
    mode: "g+rx,o+rx"

- name: Read node-token from master
  slurp:
    src: /var/lib/rancher/k3s/server/node-token
  register: node_token

- name: Store Master node-token
  set_fact:
    token: "{{ node_token.content | b64decode | regex_replace('\n', '') }}"

- name: Restore node-token file access
  file:
    path: /var/lib/rancher/k3s/server
    mode: "{{ p.stat.mode }}"

- name: Create directory .kube
  file:
    path: /root/.kube
    state: directory
    owner: "{{ ansible_user }}"

- name: Copy config file to user home directory
  copy:
    src: /etc/rancher/k3s/k3s.yaml
    dest: /root/.kube/config
    remote_src: yes
    owner: "{{ ansible_user }}"

- name: "Replace https://localhost:6443 with https://{{ arc['space']['space_domain'] }}:6443"
  command: >-
    k3s kubectl config set-cluster default
      --server=https://{{ arc['space']['space_domain'] }}:6443
      --kubeconfig /root/.kube/config
  changed_when: true
  
- name: Copy "kubectl-config" to apollo space Directory
  fetch:
    src: /root/.kube/config
    dest: "{{ apollo_space_dir }}/kubectl-config.yml"
    flat: yes
  ignore_errors: True

- name: Create kubectl symlink
  file:
    src: /usr/local/bin/k3s
    dest: /usr/local/bin/kubectl
    state: link

- name: Create crictl symlink
  file:
    src: /usr/local/bin/k3s
    dest: /usr/local/bin/crictl
    state: link